package explorviz.live_trace_processing.filter.reduction.evaluation.language_based;

import explorviz.live_trace_processing.filter.IPipeReceiver;
import explorviz.live_trace_processing.filter.reduction.language_based.AbstractLanguageBasedFilter;
import explorviz.live_trace_processing.record.event.AbstractBeforeEventRecord;

public class RemovePackageFilter extends AbstractLanguageBasedFilter {

	String packageName;

	public RemovePackageFilter(final IPipeReceiver receiver, final String packageName) {
		super(receiver, "packageFiltering");
		this.packageName = packageName;
	}

	@Override
	protected boolean isSoughtEvent(final AbstractBeforeEventRecord abstractBeforeEventRecord) {
		return abstractBeforeEventRecord.getOperationSignature().contains(packageName);
	}

}
