package explorviz.live_trace_processing.filter.reduction.language_based;

import explorviz.live_trace_processing.filter.IPipeReceiver;
import explorviz.live_trace_processing.record.event.AbstractBeforeEventRecord;

public class RemoveGettersAndSettersFilter extends AbstractLanguageBasedFilter {

	public RemoveGettersAndSettersFilter(final IPipeReceiver receiver) {
		super(receiver, "GettersAndSetters");
	}

	@Override
	protected boolean isSoughtEvent(final AbstractBeforeEventRecord abstractBeforeEventRecord) {
		return isGetterOrSetter(abstractBeforeEventRecord.getOperationSignature());
	}

	private boolean isGetterOrSetter(final String operationSignature) {
		final String methodName = getMethodName(operationSignature);
		return methodName.startsWith("get") || methodName.startsWith("set");
	}

	private String getMethodName(final String operationSignatureStr) {
		final String[] a = operationSignatureStr.split("\\(")[0].split("\\s");
		final String b = a[a.length - 1];
		final int c = b.lastIndexOf('.');
		final String methodName = b.substring(c + 1);
		return methodName;
	}

}
